//-----------------------------------------------------------------------------
// customvis.m
//
// Creates a Custom Visualization from an Animated Layer
//
// To Use this script:
//
// 1) Put the customvis.maki file in your scripts folder
// 2) Put <script id="customvis" file="scripts/customvis.maki"/> in the same group
//       as your animated layer
// 3) Done!
//
// by iPlayTheSpoons
//
//-----------------------------------------------------------------------------

#include "lib/std.mi"

Function UpdatePN(int kFrame, int vFrame);

Global AnimatedLayer PrevNext;
Global Timer VisTimer;
global int b1, b2, p1, p2, a1, a2, irany;
Global timer buttontimer1, buttontimer2, mytimer;
Global boolean time1, time2, felengedve, ok;

System.onScriptLoaded() { 

	//Rtegek lekrdezse
	Group VisGroup = getScriptGroup();
	PrevNext = VisGroup.getObject("prevnext");

	//Sebessgek belltsa
	PrevNext.setSpeed(50);

	buttontimer1 = new timer;  //makes the timers and sets their delay
	buttontimer1.setdelay(1);

	buttontimer2 = new timer;
	buttontimer2.setdelay(1);
	
	mytimer = new timer;
	mytimer.setdelay(200);

	felengedve = false;
	ok = true;
}


system.onscriptunloading() {

	delete buttontimer1;
	delete buttontimer2;
	delete mytimer;

}


UpdatePN(int kFrame, int vFrame){
	//Vis
	PrevNext.setStartFrame(kFrame);
     	PrevNext.setEndFrame(vFrame);
     	PrevNext.play();
}

PrevNext.onleftbuttondown(int x, int y) {
	if (x < 190) {
		irany = 1;
		buttontimer1.start();
		UpdatePN(6, 11);
	}
	else {
		irany = 2;
		UpdatePN(0, 5);
		buttontimer2.start();
	}
	felengedve = false;
	mytimer.start();
}

PrevNext.onleftbuttonup(int x, int y) {
	if (x < 190) {
		//Prev
		buttontimer1.stop();  //stops the timer
		if (time1==0) {
			system.previous();
		}
		time1=0;
		B1=0;
		a1=100;
	}
	else {
		//Next
		buttontimer2.stop();
		if (time2==0) {
			system.next();
		}
		time2=0;
		b2=0;
		a2=100;
	}
	felengedve = true;
}

mytimer.ontimer() {
	PrevNext.stop();
	if (irany == 1 && felengedve) {
		if (ok) {
			UpdatePN(11, 6);
			ok = false;
		}
		else {
			ok = true;
			PrevNext.stop();
			mytimer.stop();
		}
	}
	else if (irany == 2 && felengedve) {
		if (ok) {
			UpdatePN(5, 0);
			ok = false;
		}
		else {
			ok = true;
			PrevNext.stop();
			mytimer.stop();
		}
	}
}


buttontimer1.ontimer() {

	if (b1>=25) {    //checks to see if counter at bottom has reached 50 ms yet
		time1=1;  //flag for the onbuttonup command so it knows what to do
		p1=System.getposition();  //gets the current song position
		p1-=a1;  //sets the position back by a1, which is currently 100
		a1+=50;  //adds 50 to it, so the seekspeed increases
		if (p1<=0) {  //if we get to the end of the song
			System.previous();  //skip to the previous song
			a1=100;  //resets the seeksepeed to 100 again
                        p1=((System.getPlayItemLength() * 1000)-1); // gets the length of the song and goes to the end
			system.seekto(p1);//starts seeking back again
			system.play();  //triggers the play command to show the new song
		} else {
		system.seekTo(p1);   //otherwise, seek backwards
		}
	}

	b1+= 1;  //adds one to the counter
}

buttontimer2.ontimer() {

	if (b2>=25) {
		time2=1;
		p2=System.getposition();
		p2+=a2;
		a2+=50;
		if (p2>=System.getPlayItemLength() + 5) {
			System.next();
			a2=100;
			p2=(0);
		} else {
		system.seekTo(p2);
		}
	}
	b2+=1;
}
